package jarnik.ld22
{
	import org.flixel.FlxG;
	import org.flixel.FlxU;
	import org.flixel.FlxGroup;
	import org.flixel.FlxState;
	import org.flixel.FlxObject;
	import org.flixel.FlxBasic;
	import org.flixel.FlxText;
	import org.flixel.FlxSprite;
	import org.flixel.FlxPoint;
	import org.flixel.FlxCamera;
	import org.flixel.FlxRect;

	public class Animal extends FlxSprite
	{
        private var circle:FlxSprite;
        private var circleFull:FlxSprite;
        private var shadow:FlxSprite;
        public var demand:Number;
        public var temper:Number;
        public var mood:Number;

        private static const colors:Array = [
            0xff0000,
            0xff6000,
            0xffc000,
            0xdeff00,
            0x7eff00,
            0x1fff00,
            0x00ff41,
            0x00ffa1,
            0x00fdff,
            0x009dff,
            0x003dff,
            0x2300ff,
            0x8200ff,
            0xe200ff,
            0xff00bc,
            0xff005c            
        ];


        public function Animal( X:Number, Y:Number, temper:Number, demand:Number ):void {
            super( X, Y );
            loadGraphic( Assets.ImgAnimals, true );
            frame = Math.floor(FlxG.random()*frames);

            this.temper = temper;
            this.demand = demand;

            circle = new FlxSprite( 0, 0, Assets.ImgCircle );
            circle.alpha = 0.2;
            circle.color = colors[ Math.floor( temper * 16 ) ];

            circleFull = new FlxSprite( 0, 0, Assets.ImgCircleFull );
            circleFull.alpha = 0.5;

            shadow = new FlxSprite( 0, 0, Assets.ImgShadow );
            shadow.alpha = 0.5;

            updateMood( 0 );
        }

        public function updateMood( mood:Number, noSound:Boolean = false ):void {
            if ( mood <= demand ) {
                mood = mood / demand;
            } else {                
                mood = 1 - (mood - demand) / demand;
            }
            mood = Math.max( 0, mood );
            mood = Math.min( 1, mood );

            if ( this.mood != mood && mood == 1 && !noSound )  
                FlxG.play( Assets.SndHappy );

            this.mood = mood;

            circle.alpha = mood / 3;
            var moodColor:int = Number(mood*255);
            color = moodColor << 8 | moodColor << 16 | moodColor;
        }

        override public function draw():void {
            shadow.x = x;
            shadow.y = y + 12;
            shadow.draw();

            super.draw();

            if ( mood >= 1 ) {
                circleFull.x = x - 16;
                circleFull.y = y - 16;
                circleFull.draw();
            }

            circle.x = x - 16;
            circle.y = y - 16;
            circle.draw();
        }

	}
}
