package jarnik.ld22
{
	import org.flixel.FlxG;
	import org.flixel.FlxU;
	import org.flixel.FlxGroup;
	import org.flixel.FlxButton;
	import org.flixel.FlxState;
	import org.flixel.FlxObject;
	import org.flixel.FlxBasic;
	import org.flixel.FlxText;
	import org.flixel.FlxSprite;
	import org.flixel.FlxPoint;
	import org.flixel.FlxCamera;
	import org.flixel.FlxRect;

	public class TitleState extends FlxState
	{

        private var animals:FlxGroup;

        public function TitleState():void {
        }

		override public function create():void
		{
            FlxG.bgColor = 0xffe0e0e0;

            add( new FlxSprite( 0,0,Assets.ImgVignette ));

            add( new FlxSprite( 0,0,Assets.ImgTitle ));

            add( new FlxButton( 117, 111, "CONTINUE", onNext ) );

            var panel:FlxSprite;
            add( panel = new FlxSprite( 0, FlxG.height-15 ) );
            panel.makeGraphic( FlxG.width, 15, 0xff000000);
            add( new FlxText( 5, FlxG.height-15, FlxG.width, "LUDUM DARE 22 entry by Jarnik - www.jarnik.com - 12 / 2011" ).setFormat( null, 8, 0x505050 ) );

            FlxG.mouse.show(Assets.ImgCursor, 2, -16, -16 );

            add( animals = new FlxGroup() );
            var animal:Animal;
            for ( var i:int = 0; i < 12; i++ ) {
                animal = new Animal( 8 + i * 30, FlxG.height - 50, FlxG.random(), 1 );
                animals.add( animal );
                animal.updateMood( 1, true );
            }
            //updateAnimals();

            FlxG.playMusic( Assets.SndMusic );
            FlxG.flash( 0xffffffff, 1 );

		}

        private function temperDifference( t1:Number, t2:Number ):Number {
            if ( Math.abs( t1 - t2 ) < 0.5 )  
                return Math.abs( t1 - t2 );
            return 1 - Math.abs( t1 - t2 );
        }

        private function updateAnimals():void {
            var mood:Number;
            var acceptDistance:Number = 24;
            var temperAcceptRange:Number = 0.2;
            for each ( var animal:Animal in animals.members ) {
                mood = 0;
                for each ( var other:Animal in animals.members ) {
                    if ( other == animal )
                        continue;
                    if (  
                        Math.sqrt( Math.pow( animal.x - other.x,2 ) + Math.pow( animal.y - other.y,2 ) ) > acceptDistance
                    ) 
                        continue;
                    if ( temperDifference(animal.temper, other.temper) > temperAcceptRange )
                        mood--;
                    else
                        mood++;
                }
                animal.updateMood( mood );
            }
        }

        override public function update():void {
            super.update();
        }

        private function onNext():void {
            FlxG.play( Assets.SndClick );
            FlxG.switchState( new GuideState() );
        }

	}
}
